﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion
using System.ServiceProcess;
using System.Threading;
using HeuristicLab.Clients.Hive.Slave;

namespace HeuristicLab.Clients.Hive.Slave.SlaveWindowsService {
  public partial class SlaveWindowsService : ServiceBase {
    private Core core;
    private Thread coreThread;

    public SlaveWindowsService() {
      InitializeComponent();
      if (!System.Diagnostics.EventLog.SourceExists("HeuristicLab Hive Slave"))
        System.Diagnostics.EventLog.CreateEventSource("HeuristicLab Hive Slave",
                                                              "HeuristicLab Hive Slave");

      eventLog.Source = "HeuristicLab Hive Slave";
      eventLog.Log = "HeuristicLab Hive Slave";
    }

    protected override void OnStart(string[] args) {
      core = new Core();
      coreThread = new Thread(core.Start);
      coreThread.Start();
      eventLog.WriteEntry("HeuristicLab Hive Slave started!");
    }

    protected override void OnStop() {
      eventLog.WriteEntry("Shutting down HeuristicLab Hive Slave...");
      core.Shutdown();
      eventLog.WriteEntry("HeuristicLab Hive Slave stopped!");
    }
  }
}
